/*Tramvaj sa
početnog stajališta kreće bez putnika (prazan). Za svako stajalište se unose NAZIV(jedna reč),
ULAZ(broj putnika koji ulaze – ceo broj) i IZLAZ(broj putnika koji izlaze – ceo broj). Napraviti
kružnu povezanu listu, koja predstavlja trasu tramvaja broj 2, pri čemu putnici uvek mogu da uđu
u tramvaj, ali ukoliko se navede da na datom stajalištu izlazi više putnika nego što trenutno
postoji u tramvaju, tada izlaze svi putnici. Svaki element liste odgovara jednom stajalištu i sadrži
NAZIV stajališta i BROJ putnika u tramvaju u trenutku kada tramvaj kreće sa tog stajališta. Ispisati
trasu tramvaja broj 2 sa podacima NAZIV stajališta i BROJ putnika.*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct lista
{
	char *ime;
	int broj;
	struct lista *sledeci;
} lista;

#define novi(x) x=(lista*)malloc(sizeof(lista))
#define novic(x,s) x=(char*)malloc(strlen(s)+ 1)

void Ispis (lista *p)
{
	lista *pom=p;
	do
	{
		printf("Naziv = %s Broj = %d\n", pom->ime, pom->broj);
		pom=pom->sledeci;
	} while (pom != p);
	printf("\n");
}

lista* Ubaci (lista *p, char *ime, int bu, int bi)
{
	lista *q=NULL, *pom=p;
	
	novi(q);
	novic(q->ime, ime);
	strcpy(q->ime, ime);
	
	if (p==NULL)
	{
		p=q;
		p->sledeci=p;
		p->broj=bu;
	}
	else
	{
		while (pom->sledeci != p) pom=pom->sledeci;
		
		if (bi > pom->broj) q->broj=bu;
		else q->broj=pom->broj-bi+bu;
		pom->sledeci=q;
		q->sledeci=p;
	}
	
	return p;
}

lista* Formiraj (lista *p, FILE *f)
{
	int i, n, bu, bi;
	char ime[100];
	
	fscanf(f, "%d", &n);
	
	for (i=0; i<n; i++)
	{
		fgetc(f);
		fgets(ime, 100, f);
		fscanf(f, "%d", &bu);
		fscanf(f, "%d", &bi);
		p=Ubaci(p, ime, bu, bi);
	}
	return p;
}

/*Tramvaj nastavlja da kruži, i za svako trenutno stajalište se ponovo unose samo brojevi putnika
(bez naziva stajališta) koji ulaze i koji izlaze iz tramvaja. Ukoliko na nekom stajalištu niko ne uđe i
ne izađe u sledećim prolascima na tom stajalištu tramvaj ne staje. Tramvaj kruži bez prestanka
sve dok ne ostane samo jedno stajalište na kom završava svoju smenu i svi putnici koji se nalaze u
tom trenutku u tramvaju izlaze iz njega. Nakon svakog kruga (kad god tramvaj stigne do polaznog
stajališta) ispisati trasu tramvaja.
NAPOMENA: Smatra se da će tramvaj u nekom trenutku sigurno završiti smenu.*/

int main (int argc, char *argv[])
{
	FILE *f=fopen(argv[1], "r");
	lista *p=NULL, *pom=NULL, *t=NULL;
	int bu=0, bi=0;
	p=Formiraj(p, f);
	if (p)
	{
		printf("Trasa tramvaja broj 2\n");
		Ispis(p);
		pom=p;
		while (1)
		{
			pom=p;
			t=p;
			do
			{
				t=p;
				scanf("%d", &bu);
				scanf("%d", &bi);
				
				if ((bu == 0) && (bi==0)) 
				{
					if (pom == p)
					{
						while (t->sledeci != p) t=t->sledeci;
						t->sledeci=p->sledeci;
						p=p->sledeci;
					}
					else
					{
						while (t->sledeci != pom) t=t->sledeci;
						t->sledeci=pom->sledeci;
					} 
				}
				else 
				{
					if (bi > pom->broj) pom->broj=bu;
					else pom->broj=pom->broj-bi+bu;
					
				}	
			}
			while (pom !=p);
			Ispis(p);
			
			if (p->sledeci == p) break;
		}
	}
	else printf("Lista je prazna \n");
	return 0;
}
	
