/*
 * Na ulazu se zadaje ceo broj N a zatim N Fajlova.
 * Elementi strukture Fajl su
 *      NAZIV_FAJLA(jednareč),
 *      VELICINA_FAJLA(realan broj) i
 *      EKSTENZIJA(jedna reč).
 *
 * Formirati binarno stablo čiji su elementi Fajlovi i koje je uređeno u odnosu na VELICINA_FAJLA.

 * Ispisati Fajlove ali tako da se prvo ispišu fajlovi najveće veličine.
 *
 *  Za unetu ekstenziju EKS i veličinu fajla VL od formiranog binarnog stabla formirati novo uređeno po istom kriterijumu
 * ali koje sadrži samo one čvore prvog stabla koji su date ekstenzije i veličina im je veća od unete veličine VL.
 *
 * Ispisati novoformirano stablo od fajlova najveće veličine.
 *
NAPOMENA: Maksimalan broj poena se dobija ukoliko se optimizuje obilazak stabla.*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct Fajl
{
    char *naziv;
    double velicina;
    char *ekstenzija;

    struct Fajl *levi, *desni;
};


void Dodaj (struct Fajl **p, char *n, double v, char *e)
{
    struct Fajl*novi;

    novi = (struct Fajl *) malloc (sizeof(struct Fajl));
    if(novi == NULL)
    {
        printf("Greska!");
        exit(0);
    }


    novi->naziv = (char *) malloc(strlen(n) +1);
    strcpy(novi->naziv, n);

    novi->velicina = v;
    novi->ekstenzija =(char *) malloc(strlen(e) +1);
    strcpy(novi->ekstenzija, e);
    novi->desni = novi->levi = NULL;

    if((*p) == NULL)
    {
        (*p) = novi;
    }
    else
    {
        struct Fajl *pom1, *pom2;
        pom1 = (*p);
        while(pom1 != NULL)
        {
            pom2 = pom1;
            if(v < pom1->velicina)
                pom1 = pom1 ->levi;
            else
                pom1 = pom1 ->desni;
        }

        if(v < pom2->velicina )
            pom2 -> levi = novi;
        else
            pom2->desni = novi;

    }
}


struct Fajl * Ucitaj ()
{
    struct Fajl *p = NULL;
    int i,n;
    double v;
    char s1[50],s2[50];

    printf("Unesi n: ");
    scanf("%d",&n);

    for(i=0; i<n;i++)
    {
        printf("\nnaziv fajla:  ");
        scanf("%s",s1);
        printf("velicina fajla ");
        scanf("%lf", &v);
        printf("ekstenzija fajla ");
        scanf("%s",s2);

        Dodaj(&p, s1, v, s2);
    }

    return p;
}


void pisi_DKL (struct Fajl *p)
{
    if(p)
    {
        pisi_DKL(p->desni);
        printf("%s.%s \t %.2lf \n", p->naziv, p->ekstenzija, p->velicina);
        pisi_DKL(p->levi);
    }
}


/*
Za unetu ekstenziju EKS i veličinu fajla VL od formiranog binarnog stabla formirati novo uređeno po istom kriterijumu
* ali koje sadrži samo one čvore prvog stabla koji su date ekstenzije i veličina im je veća od unete veličine VL.
*/

void Novo (struct Fajl *p, struct Fajl **q, char *EKS, double VL)
{
    if(p)
    {
        if( strcmp(p->ekstenzija, EKS) ==0  && p->velicina > VL )
            Dodaj(q,p->naziv, p->velicina, p->ekstenzija);

        if(p->velicina > VL) Novo(p ->levi,q,EKS,VL);
        Novo(p->desni, q,EKS, VL);

    }
}



 main()
{
    struct Fajl *p, *q;
    p = q =NULL;
    char EKS[50];
    double VL;
    p = Ucitaj();
    pisi_DKL(p);
    printf("\n\nUnesite EKS: ");
    scanf("%s",EKS);
    printf("Unesite VL: ");
    scanf("%lf", &VL);

    Novo(p,&q,EKS,VL);
    printf("\n\n Novo stabo \n\n");
    pisi_DKL(q);

}

