#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct lista
{
	char naziv[50];
	int broj;
	struct lista *sledeci;
} lista;

#define aloc(x) x=(lista*)malloc(sizeof(lista))

void dodaj(lista **p,char naziv[],int broj);
void formiraj(lista **p,char dat[]);
void stampaj(lista *p);
void izmeni(lista **p);

int main(int argc, char *argv[])
{
	if(argc!=2)
	{
		printf("Greska! Upotreba: %s ime_datoteke\n",argv[0]);
		exit (1);
	}
	
	lista *p=NULL;
	
	formiraj(&p,argv[1]);
	stampaj(p);
	izmeni(&p);
}

void dodaj(lista **p,char naziv[],int broj)
{
	lista *t,*pom;
	aloc(t);
	strcpy(t->naziv,naziv);
	t->broj=broj;
	
	if(*p==NULL)
	{
		*p=t;
		t->sledeci=t;
	}
	else
	{
		pom=*p;
		while(pom->sledeci!=*p) pom=pom->sledeci;
		pom->sledeci=t;
		t->sledeci=*p;
	}
}

void formiraj(lista **p,char dat[])
{
	FILE *f=fopen(dat,"r");
	if(!f)
	{
		printf("Greska prilikom ucitavanja datoteke!\n");
		exit(1);
	}
	
	int ulaz,izlaz,i,n,ukupno=0;
	char naziv[50];
	
	fscanf(f,"%d",&n);
	
	for(i=0;i<n;i++)
	{
		fscanf(f,"%s",naziv);
		fscanf(f,"%d%d",&ulaz,&izlaz);
		ukupno-=izlaz;
		if(ukupno<0) ukupno=0;
		ukupno+=ulaz;
		dodaj(p,naziv,ukupno);
	}
	
	fclose(f);
}
	
void stampaj(lista *p)
{
	lista *pom=p;
	if(pom)
	{
		do
		{
			printf("%s\t%d\n",pom->naziv,pom->broj);
			pom=pom->sledeci;
		} while(pom!=p);
	}
	printf("\n\n");
}

void izmeni(lista **p)
{
	lista *pom,*t,*posl;
	int ulaz,izlaz,ind=0;
	
	while((*p)&&((*p)->sledeci!=*p))
	{
		posl=*p;
		while(posl->sledeci!=*p) posl=posl->sledeci;
		scanf("%d%d",&ulaz,&izlaz);
		(*p)->broj-=izlaz;
		if((*p)->broj<0) (*p)->broj=0;
		(*p)->broj+=ulaz;
		while((ulaz==0)&&(izlaz==0))
		{
			t=*p;
			if(*p==(*p)->sledeci)
			{
				(*p)->broj=0;
				printf("Poslednja stanica je %s i svi putnici treba da izadju.\n",(*p)->naziv);
				free(t);
				ind=1;
				break;
			}

			*p=(*p)->sledeci;
			posl->sledeci=*p;
			(*p)->broj+=t->broj;
			free(t);
			scanf("%d%d",&ulaz,&izlaz);
			(*p)->broj-=izlaz;
			if((*p)->broj<0) (*p)->broj=0;
			(*p)->broj+=ulaz;
			
		}
		if(ind==1) break;
		if(*p)
		{
		pom=*p;
		while(pom->sledeci!=*p)
		{
			scanf("%d%d",&ulaz,&izlaz);
			(*p)->broj-=izlaz;
			if((*p)->broj<0) (*p)->broj=0;
			(*p)->broj+=ulaz;
			if((ulaz==0)&&(izlaz==0))
			{
				t=pom->sledeci;
				pom->sledeci=pom->sledeci->sledeci;
				pom->sledeci->broj+=t->broj;
				free(t);
				
			}
			else pom=pom->sledeci;
		}
		}
		
		if(*p==(*p)->sledeci)
		{
			(*p)->broj=0;
			printf("Poslednja stanica je %s i svi putnici treba da izadju.\n",(*p)->naziv);
			break;
		}
		else stampaj(*p);
	}
}


	
	
	
